---
title: WebGLRenderingContext.texImage2D()
slug: Web/API/WebGLRenderingContext/texImage2D
tags:
  - API
  - Method
  - Reference
  - Textures
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.texImage2D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API </a>specifies a two-dimensional texture image.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">// WebGL1:
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>width</var>, <var>height</var>, <var>border</var>, <var>format</var>, <var>type</var>, ArrayBufferView? <var>pixels</var>);
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>format</var>, <var>type</var>, ImageData? <var>pixels</var>);
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>format</var>, <var>type</var>, HTMLImageElement? <var>pixels</var>);
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>format</var>, <var>type</var>, HTMLCanvasElement? <var>pixels</var>);
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>format</var>, <var>type</var>, HTMLVideoElement? <var>pixels</var>);
void <var>gl</var>.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, <var>format</var>, <var>type</var>, ImageBitmap? <var>pixels</var>);

// WebGL2:
void gl.texImage2D(<var>target</var>, <var>level</var>, <var>internalformat</var>, width, <var>height</var>, <var>border</var>, <var>format</var>, <var>type</var>, GLintptr <var>offset</var>);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, HTMLCanvasElement source);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, HTMLImageElement source);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, HTMLVideoElement source);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, ImageBitmap source);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, ImageData source);
void gl.texImage2D(target, level, internalformat, width, height, border, format, type, ArrayBufferView srcData, srcOffset);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target) of the active texture. Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A two-dimensional texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_X</code>: Positive X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_X</code>: Negative X face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Y</code>: Positive Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Y</code>: Negative Y face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Z</code>: Positive Z face for a cube-mapped texture.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Z</code>: Negative Z face for a cube-mapped texture.</li>
 </ul>
 </dd>
 <dt><code>level</code></dt>
 <dd>A {{domxref("GLint")}} specifying the level of detail. Level 0 is the base image level and level <em>n</em> is the <em>n</em>th mipmap reduction level.</dd>
 <dt><code>internalformat</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the color components in the texture.</dd>
 <dd>Possible values in both WebGL1 and WebGL2</dd>
 <dt>
 <table>
  <thead>
   <tr>
    <td>Format</td>
    <td>Type</td>
    <td>Channels</td>
    <td>Bytes per pixel</td>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td>RGBA</td>
    <td>UNSIGNED_BYTE</td>
    <td>4</td>
    <td>4</td>
   </tr>
   <tr>
    <td>RGB</td>
    <td>UNSIGNED_BYTE</td>
    <td>3</td>
    <td>3</td>
   </tr>
   <tr>
    <td>RGBA</td>
    <td>UNSIGNED_SHORT_4_4_4_4</td>
    <td>4</td>
    <td>2</td>
   </tr>
   <tr>
    <td>RGBA</td>
    <td>UNSIGNED_SHORT_5_5_5_1</td>
    <td>4</td>
    <td>2</td>
   </tr>
   <tr>
    <td>RGB</td>
    <td>UNSIGNED_SHORT_5_6_5</td>
    <td>3</td>
    <td>2</td>
   </tr>
   <tr>
    <td>LUMINANCE_ALPHA</td>
    <td>UNSIGNED_BYTE</td>
    <td>2</td>
    <td>2</td>
   </tr>
   <tr>
    <td>LUMINANCE</td>
    <td>UNSIGNED_BYTE</td>
    <td>1</td>
    <td>1</td>
   </tr>
   <tr>
    <td>ALPHA</td>
    <td>UNSIGNED_BYTE</td>
    <td>1</td>
    <td>1</td>
   </tr>
  </tbody>
 </table>
 </dt>
 <dd>Other possible values in WebGL2 for the versions of <code>texImage2D</code> that take an <code>ArrayBufferView</code> or a <code>GLintptr offset</code></dd>
</dl>

<table>
 <thead>
  <tr>
   <td><strong>Sized<br>
    Format</strong></td>
   <td><strong>Base<br>
    Format</strong></td>
   <td><strong>R<br>
    bits</strong></td>
   <td><strong>G<br>
    bits</strong></td>
   <td><strong>B<br>
    bits</strong></td>
   <td><strong>A<br>
    bits</strong></td>
   <td><strong>Shared<br>
    bits</strong></td>
   <td><strong>Color<br>
    renderable</strong></td>
   <td><strong>Texture<br>
    filterable</strong></td>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>R8</td>
   <td>RED</td>
   <td>8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>R8_SNORM</td>
   <td>RED</td>
   <td>s8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RG8</td>
   <td>RG</td>
   <td>8</td>
   <td>8</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RG8_SNORM</td>
   <td>RG</td>
   <td>s8</td>
   <td>s8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB8</td>
   <td>RGB</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td></td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB8_SNORM</td>
   <td>RGB</td>
   <td>s8</td>
   <td>s8</td>
   <td>s8</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB565</td>
   <td>RGB</td>
   <td>5</td>
   <td>6</td>
   <td>5</td>
   <td></td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGBA4</td>
   <td>RGBA</td>
   <td>4</td>
   <td>4</td>
   <td>4</td>
   <td>4</td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB5_A1</td>
   <td>RGBA</td>
   <td>5</td>
   <td>5</td>
   <td>5</td>
   <td>1</td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGBA8</td>
   <td>RGBA</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGBA8_SNORM</td>
   <td>RGBA</td>
   <td>s8</td>
   <td>s8</td>
   <td>s8</td>
   <td>s8</td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB10_A2</td>
   <td>RGBA</td>
   <td>10</td>
   <td>10</td>
   <td>10</td>
   <td>2</td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB10_A2UI</td>
   <td>RGBA</td>
   <td>ui10</td>
   <td>ui10</td>
   <td>ui10</td>
   <td>ui2</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>SRGB8</td>
   <td>RGB</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>SRGB8_ALPHA8</td>
   <td>RGBA</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td>8</td>
   <td></td>
   <td>●</td>
   <td>●</td>
  </tr>
  <tr>
   <td>R16F</td>
   <td>RED</td>
   <td>f16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RG16F</td>
   <td>RG</td>
   <td>f16</td>
   <td>f16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB16F</td>
   <td>RGB</td>
   <td>f16</td>
   <td>f16</td>
   <td>f16</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGBA16F</td>
   <td>RGBA</td>
   <td>f16</td>
   <td>f16</td>
   <td>f16</td>
   <td>f16</td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>R32F</td>
   <td>RED</td>
   <td>f32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RG32F</td>
   <td>RG</td>
   <td>f32</td>
   <td>f32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB32F</td>
   <td>RGB</td>
   <td>f32</td>
   <td>f32</td>
   <td>f32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA32F</td>
   <td>RGBA</td>
   <td>f32</td>
   <td>f32</td>
   <td>f32</td>
   <td>f32</td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>R11F_G11F_B10F</td>
   <td>RGB</td>
   <td>f11</td>
   <td>f11</td>
   <td>f10</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>RGB9_E5</td>
   <td>RGB</td>
   <td>9</td>
   <td>9</td>
   <td>9</td>
   <td></td>
   <td>5</td>
   <td></td>
   <td>●</td>
  </tr>
  <tr>
   <td>R8I</td>
   <td>RED</td>
   <td>i8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>R8UI</td>
   <td>RED</td>
   <td>ui8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>R16I</td>
   <td>RED</td>
   <td>i16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>R16UI</td>
   <td>RED</td>
   <td>ui16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>R32I</td>
   <td>RED</td>
   <td>i32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>R32UI</td>
   <td>RED</td>
   <td>ui32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG8I</td>
   <td>RG</td>
   <td>i8</td>
   <td>i8</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG8UI</td>
   <td>RG</td>
   <td>ui8</td>
   <td>ui8</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG16I</td>
   <td>RG</td>
   <td>i16</td>
   <td>i16</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG16UI</td>
   <td>RG</td>
   <td>ui16</td>
   <td>ui16</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG32I</td>
   <td>RG</td>
   <td>i32</td>
   <td>i32</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RG32UI</td>
   <td>RG</td>
   <td>ui32</td>
   <td>ui32</td>
   <td></td>
   <td></td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGB8I</td>
   <td>RGB</td>
   <td>i8</td>
   <td>i8</td>
   <td>i8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB8UI</td>
   <td>RGB</td>
   <td>ui8</td>
   <td>ui8</td>
   <td>ui8</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB16I</td>
   <td>RGB</td>
   <td>i16</td>
   <td>i16</td>
   <td>i16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB16UI</td>
   <td>RGB</td>
   <td>ui16</td>
   <td>ui16</td>
   <td>ui16</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB32I</td>
   <td>RGB</td>
   <td>i32</td>
   <td>i32</td>
   <td>i32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGB32UI</td>
   <td>RGB</td>
   <td>ui32</td>
   <td>ui32</td>
   <td>ui32</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA8I</td>
   <td>RGBA</td>
   <td>i8</td>
   <td>i8</td>
   <td>i8</td>
   <td>i8</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA8UI</td>
   <td>RGBA</td>
   <td>ui8</td>
   <td>ui8</td>
   <td>ui8</td>
   <td>ui8</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA16I</td>
   <td>RGBA</td>
   <td>i16</td>
   <td>i16</td>
   <td>i16</td>
   <td>i16</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA16UI</td>
   <td>RGBA</td>
   <td>ui16</td>
   <td>ui16</td>
   <td>ui16</td>
   <td>ui16</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA32I</td>
   <td>RGBA</td>
   <td>i32</td>
   <td>i32</td>
   <td>i32</td>
   <td>i32</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
  <tr>
   <td>RGBA32UI</td>
   <td>RGBA</td>
   <td>ui32</td>
   <td>ui32</td>
   <td>ui32</td>
   <td>ui32</td>
   <td></td>
   <td>●</td>
   <td></td>
  </tr>
 </tbody>
</table>

<dl>
 <dd>
 <p><br>
  Possible values in WebGL2 for the versions of <code>texImage2D</code> that take a texture an <code>HTMLImageElement</code>, <code>HTMLCanvasElement</code>, <code>HTMLVideoElement</code>, <code>ImageBitmap</code>, or <code>ImageData</code></p>

 <ul>
  <li><code>gl.ALPHA</code>: Discards the red, green and blue components and reads the alpha component.</li>
  <li><code>gl.RGB</code>: Discards the alpha components and reads the red, green and blue components.</li>
  <li><code>gl.RGBA</code>: Red, green, blue and alpha components are read from the color buffer.</li>
  <li><code>gl.LUMINANCE</code>: Each color component is a luminance component, alpha is 1.0.</li>
  <li><code>gl.LUMINANCE_ALPHA</code>: Each component is a luminance/alpha component.</li>
  <li>When using the {{domxref("WEBGL_depth_texture")}} extension:
   <ul>
    <li><code>gl.DEPTH_COMPONENT</code></li>
    <li><code>gl.DEPTH_STENCIL</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("EXT_sRGB")}} extension:
   <ul>
    <li><code>ext.SRGB_EXT</code></li>
    <li><code>ext.SRGB_ALPHA_EXT</code></li>
   </ul>
  </li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.R8</code></li>
    <li><code>gl.R16F</code></li>
    <li><code>gl.R32F</code></li>
    <li><code>gl.R8UI</code></li>
    <li><code>gl.RG8</code></li>
    <li><code>gl.RG16F</code></li>
    <li><code>gl.RG32F</code></li>
    <li><code>gl.RG8UI</code></li>
    <li><code>gl.RG16UI</code></li>
    <li><code>gl.RG32UI</code></li>
    <li><code>gl.RGB8</code></li>
    <li><code>gl.SRGB8</code></li>
    <li><code>gl.RGB565</code></li>
    <li><code>gl.R11F_G11F_B10F</code></li>
    <li><code>gl.RGB9_E5</code></li>
    <li><code>gl.RGB16F</code></li>
    <li><code>gl.RGB32F</code></li>
    <li><code>gl.RGB8UI</code></li>
    <li><code>gl.RGBA8</code></li>
    <li><code>gl.SRGB8_ALPHA8</code></li>
    <li><code>gl.RGB5_A1</code></li>
    <li><code>gl.RGB10_A2</code></li>
    <li><code>gl.RGBA4</code></li>
    <li><code>gl.RGBA16F</code></li>
    <li><code>gl.RGBA32F</code></li>
    <li><code>gl.RGBA8UI</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the texture.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the texture.</dd>
 <dt><code>border</code></dt>
 <dd>A {{domxref("GLint")}} specifying the width of the border. Must be 0.</dd>
 <dt><code>format</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the format of the texel data. In WebGL 1, this must be the same as <code>internalformat</code> (see above). in WebGL 2, the combinations are listed in <a href="https://www.khronos.org/registry/webgl/specs/latest/2.0/#TEXTURE_TYPES_FORMATS_FROM_DOM_ELEMENTS_TABLE">this table</a>.</dd>
 <dt><code>type</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the data type of the texel data. Possible values:
 <ul>
  <li><code>gl.UNSIGNED_BYTE</code>: 8 bits per channel for <code>gl.RGBA</code></li>
  <li><code>gl.UNSIGNED_SHORT_5_6_5</code>: 5 red bits, 6 green bits, 5 blue bits.</li>
  <li><code>gl.UNSIGNED_SHORT_4_4_4_4</code>: 4 red bits, 4 green bits, 4 blue bits, 4 alpha bits.</li>
  <li><code>gl.UNSIGNED_SHORT_5_5_5_1</code>: 5 red bits, 5 green bits, 5 blue bits, 1 alpha bit.</li>
  <li>When using the {{domxref("WEBGL_depth_texture")}} extension:
   <ul>
    <li><code>gl.UNSIGNED_SHORT</code></li>
    <li><code>gl.UNSIGNED_INT</code></li>
    <li><code>ext.UNSIGNED_INT_24_8_WEBGL</code> (constant provided by the extension)</li>
   </ul>
  </li>
  <li>When using the {{domxref("OES_texture_float")}} extension:
   <ul>
    <li><code>gl.FLOAT</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("OES_texture_half_float")}} extension:
   <ul>
    <li><code>ext.HALF_FLOAT_OES</code> (constant provided by the extension)</li>
   </ul>
  </li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.BYTE</code></li>
    <li><code>gl.UNSIGNED_SHORT</code></li>
    <li><code>gl.SHORT</code></li>
    <li><code>gl.UNSIGNED_INT</code></li>
    <li><code>gl.INT</code></li>
    <li><code>gl.HALF_FLOAT</code></li>
    <li><code>gl.FLOAT</code></li>
    <li><code>gl.UNSIGNED_INT_2_10_10_10_REV</code></li>
    <li><code>gl.UNSIGNED_INT_10F_11F_11F_REV</code></li>
    <li><code>gl.UNSIGNED_INT_5_9_9_9_REV</code></li>
    <li><code>gl.UNSIGNED_INT_24_8</code></li>
    <li><code>gl.FLOAT_32_UNSIGNED_INT_24_8_REV</code> (pixels must be {{jsxref("null")}})</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt><code>pixels</code></dt>
 <dd>One of the following objects can be used as a pixel source for the texture:
 <ul>
  <li>{{domxref("ArrayBufferView")}},
   <ul>
    <li>A {{jsxref("Uint8Array")}} must be used if <code>type</code> is <code>gl.UNSIGNED_BYTE</code>.</li>
    <li>A {{jsxref("Uint16Array")}} must be used if <code>type</code> is either <code>gl.UNSIGNED_SHORT_5_6_5</code>, <code>gl.UNSIGNED_SHORT_4_4_4_4</code>, <code>gl.UNSIGNED_SHORT_5_5_5_1</code>, <code>gl.UNSIGNED_SHORT</code> or <code>ext.HALF_FLOAT_OES</code>.</li>
    <li>A {{jsxref("Uint32Array")}} must be used if <code>type</code> is <code>gl.UNSIGNED_INT</code> or <code>ext.UNSIGNED_INT_24_8_WEBGL</code>.</li>
    <li>A {{jsxref("Float32Array")}} must be used if <code>type</code> is <code>gl.FLOAT</code>.</li>
   </ul>
  </li>
  <li>{{domxref("ImageData")}},</li>
  <li>{{domxref("HTMLImageElement")}},</li>
  <li>{{domxref("HTMLCanvasElement")}},</li>
  <li>{{domxref("HTMLVideoElement")}},</li>
  <li>{{domxref("ImageBitmap")}}.</li>
 </ul>
 </dd>
 <dt>offset</dt>
 <dd>(WebGL 2 only) A {{domxref("GLintptr")}} byte offset into the {{domxref("WebGLBuffer")}}'s data store. Used to upload data to the currently bound {{domxref("WebGLTexture")}} from the <code>WebGLBuffer</code> bound to the <code>PIXEL_UNPACK_BUFFER</code> target.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, image);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.8", "texImage2D")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glTexImage2D.xml", "glTexImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2.0 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.6", "texImage2D")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Updated definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glTexImage2D.xhtml", "glTexImage2D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3.0 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.texImage2D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bindTexture()")}}</li>
 <li>{{domxref("WebGLRenderingContext.texSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.copyTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getTexParameter()")}}</li>
 <li>{{domxref("WEBGL_depth_texture")}}</li>
 <li>{{domxref("OES_texture_float")}}</li>
 <li>{{domxref("OES_texture_half_float")}}</li>
 <li>{{domxref("EXT_texture_norm16")}}</li>
 <li>{{domxref("EXT_sRGB")}}</li>
</ul>
